<?php
if (eregi("block-WeatherHarvest.php",$_SERVER['PHP_SELF'])) 
{
  Header("Location: index.php");
  die();
}

$module_name = "WeatherHarvest";
get_lang($module_name);

require_once( "modules/$module_name/d_config.php" );
require_once( "modules/$module_name/wh_utils.php" );
require_once( "modules/$module_name/wh_ini.php" );

global $user, $Version_Num, $db, $prefix, $admin;

$wh = new whini( $db, $prefix );

//	 These will be in the admin database eventually
$process_type = $wh->getprocesstype(); // HTTP or FTP
$mini_block = $wh->getminiblock(); // true or false
$local_file_path = $wh->getrootcachepath();

/******************************************************************************/
/******************* Do NOT CHANGE THE FOLLOWING VALUE ************************/
//$ftp_server = "ftp://tgftp.nws.noaa.gov/";
$ftp_server = "ftp://weather.noaa.gov/";
$remote_file_path = "data/observations/metar/stations/";
$http_server = "http://weather.noaa.gov/cgi-bin/mgetmetar.pl";
$http_post_data = "?cccc=";  // the METAR city code is appended to this
/******************************************************************************/
/******************************************************************************/

// find out what the default for the user or site is
$uid = 0;  // default

// check to see if admin first
if ( is_admin( $admin ) )
{
  $uid = 0;
}

if ( is_user( $user ) ) 
{
  $userinfo = getusrinfo( $user );

  if ($Version_Num == "6.0" )  // look for NUKE 6.0 or earlier version
  {
    $uid = $userinfo["uid"];
  }
  else                   // after NUKE 6.0 versions
  {
    $uid = $userinfo["user_id"];
  }
}

$sql = "select code from ".$prefix."_weatherdefaults where uid=".$uid;
$result = $db->sql_query($sql);
if ($result)
{
  if ($db->sql_affectedrows() != false )
  {
    $row = $db->sql_fetchrow( $result );
    $code = $row[code];
  }
  else
  {
    $sql = "select code from ".$prefix."_weatherdefaults where uid=0";
    $result = $db->sql_query($sql);
    $row = $db->sql_fetchrow( $result );
    $code = $row[code];
  }
}
else  // use the site defualt (uid=0)
{
  $sql = "select code from ".$prefix."_weatherdefaults where uid=0";
  $result = $db->sql_query($sql);
  $row = $db->sql_fetchrow( $result );
  $code = $row[code];
}
$db->sql_freeresult( $result );

$sql = "select country, region, repstation from ".$prefix."_weatherstations where code='".$code."'";
$result = $db->sql_query( $sql );
$row = $db->sql_fetchrow( $result );
$db->sql_freeresult( $result );

$sql = "select name from ".$prefix."_weathercountries where abbrev='".$row[country]."'";
$result = $db->sql_query($sql);
$c_name = $db->sql_fetchrow( $result );
$db->sql_freeresult( $result);

if ($c_name[name] != "")
{
  $country = $c_name[name];
}
else
{
  $country = $row[country];
}

$region = $row[region];
$repstation = $row[repstation];

$content = "<table><tr><td colspan=\"2\">"._CURRENT_CONDITIONS."</td></tr><tr><td colspan=\"2\">"
          .$repstation."</td></tr>\n";
		  
if ( $mini_block != "YES" )
{		  
  $content .= "<tr><td>"._REGION."</td><td>"._COUNTRY."</td></tr>\n"
             ."<tr><td>".$region."</td><td>".$country."</td></tr>\n";
}

$content .= "</table>\n";			 

$remote_file = $remote_file_path.$code.".TXT";
$local_file = $local_file_path.$code.".TXT";

$getfile = false;
$fileexists = false;

if ( file_exists( $local_file ) )
{
  $fileexists = true;

  $filetime = filemtime( $local_file );
  $nowtime = time();

  if ( $nowtime > ($filetime + ( 60 * 30 ) ) )
  {
    $getfile = true;
  }
}
else
{
  $getfile = true;
}

if ( $getfile == true )
{
  // first, clean up the cache directory
  fnCacheCleanup( $local_file_path );

    // create custom error handler

  error_reporting(0);  // turn off error reporting, I'm handling for now.

  $old_e_handler = set_error_handler( "WMErrorHandler" );

  if ( $process_type == "FTP" )
  {
/*********************************************************************************/
/* This is for the FTP connectivity                                              */
/*********************************************************************************/
// set up basic connection
    $return = "";
    $download = fopen( "$ftp_server$remote_file", "rb" );
    if ( $download )
    {
      while( !feof( $download ) )
      {
        $return .= fgets( $download, "1024" );
      }
      fclose( $download );
    }

    if ( $return != "" )
    {
      $outfile = fopen( $local_file, "wb");
      fwrite($outfile, $return);
      fclose($outfile);
    }
/*********************************************************************************/
/* This ends the FTP connectivity                                                */
/*********************************************************************************/
  }
  else
  {
/*********************************************************************************/
/* This begins the HTTP connectivity                                             */
/*********************************************************************************/
  // set up the connection
    $download = fopen( $http_server.$http_post_data.$code, "rb" );
    $return = "";
    $exp = "(".$code." [0-9]{6}Z)";

    if ($download)
    {
      while( $line = fgets( $download, 1024 ) )
      {
        if (ereg( $exp, $line ))
        {
          $return .= $line;
          break;
        }
      }
    }
    fclose( $download );
  
    $temp = fopen( $local_file, "wb" );
    fwrite( $temp, $return );
    fclose( $temp );
  }
/*********************************************************************************/
/* This ends the HTTP connectivity                                               */
/*********************************************************************************/

  // restore default error handler

  restore_error_handler();
}

if (file_exists($local_file) )
{
  $content .= processMETARFile( $local_file, $mini_block );
}
else
{
  $content .= _WEATHER_NOT_AVAILABLE;
}

if ($wh->getshowradar() == true ) 
{
  if ( fnCheckRadarEntries( $code ) == true ) 
  {
    $content .= "<hr><a href=\"modules.php?name=".$module_name."&amp;op="._DIS_RADAR."&amp;code=".$code."\">"._LOCAL_RADAR."</a>\n";
  }
}
?>
