
<?php
######################################################################
# Weather Magnet
# ============================================
#
# Copyright (c) 2003 by John Horne seventhseal@ibdeeming.com
# http://ibdeeming.com
#
#
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################
require_once("mainfile.php");

$module_name = basename(dirname(__FILE__));
get_lang($module_name);

require_once( "modules/$module_name/wh_ini.php" );

$NOAAradar = "http://www.crh.noaa.gov/radar/images/DS.p19r0/SI.:noaaradar:/latest.gif";
/**************************************************************************************************************/
/*                                                                                                            */
/* function fnCheckRadarEntries( $code )                                                                      */
/* passed variable : $code - corresponds to the code in the weatherstations table                             */
/*                                                                                                            */
/* Returns true if any of primaryradar, secondaryradar, or userradar contains data                            */
/*                                                                                                            */
/**************************************************************************************************************/

function fnCheckRadarEntries( $code )
{
  global $prefix, $db;

  $return = false;

  $sql = "select primaryradar, secondaryradar, userradar from ".$prefix."_weatherstations where code='".$code."'";
  $result = $db->sql_query( $sql );

  if ( $result )
  {
    $row = $db->sql_fetchrow( $result );

    if ( strlen( $row[primaryradar] ) > 0  || strlen( $row[secondaryradar] ) > 0 || strlen( $row[userradar] ) > 0 )
    {
      $return = true;
    }
  }

  $db->sql_freeresult( $result );

  return $return;
}

/*******************************************************************************************************************/
/*                                                                                                                 */
/* function fnShowAllRadar( $code )                                                                                */
/* passed variable : $code - corresponds to the code in table weatherstations                                      */
/*                                                                                                                 */
/* function will display all corresponding defined radars for specified code                                       */
/*                                                                                                                 */
/*******************************************************************************************************************/

function fnShowAllRadar( $code )
{
  global $prefix, $db, $index, $NOAAradar;

  $index = 0; // don't show right side blocks
  
  $sql = "select repstation, primaryradar, secondaryradar, userradar from ".$prefix."_weatherstations where code='".$code."'";
  $result = $db->sql_query( $sql );
  $row = $db->sql_fetchrow( $result );

  $repstation = $row[repstation];
  if ($row[primaryradar] != "")
  {
    $primaryradar = ereg_replace( ":noaaradar:", $row[primaryradar], $NOAAradar );
  }
  else
  {
    $primaryradar = "";
  }
 
  if ($row[secondaryradar] != "") 
  {
    $secondaryradar = ereg_replace( ":noaaradar:", $row[secondaryradar], $NOAAradar );
  }
  else
  {
    $secondaryradar = "";
  }

  $userradar = $row[userradar];

  $db->sql_freeresult( $result );


  include("header.php");
  OpenTable();

  echo "<table><th>\n";
  echo $repstation."<br>";

  if ( $primaryradar != "")
  {
    $return = fnmap2cache( $primaryradar, $code, "p", "620", "620" );
    echo _PRI_REPORTING_STATION."</th><tr><td>".$return."</td></tr><th>\n";
  }

  if ( $secondaryradar != "")
  {
    $return = fnmap2cache( $secondaryradar, $code, "s", "620", "620" );
    echo _SEC_REPORTING_STATION."</th><tr><td>".$return."</td></tr><th>\n";
  }

  if ( $userradar != "" ) 
  {
    $return = fnmap2cache( $userradar, $code, "u", "620", "620" );
    echo _USR_REPORTING_STATION."</th><tr><td>".$return."</td></tr>\n";
  }

  echo "</table>\n";

  CloseTable();
  include("footer.php");
}


function fnmap2cache ( $URL, $code, $pre, $width = "", $height = "" )
{
  global $db, $prefix;

  $wh = new whini( $db, $prefix );
  $radar_cache = $wh->getrootradarpath();
  $url_img_path = $wh->getnukeradarpath();
  
  $IMGNAME = $pre.$code.substr( $URL, strrpos($URL, "/")+1);
  $target_file = $radar_cache.$IMGNAME;
  $url_target_file = $url_img_path.$IMGNAME;

  if ( file_exists($target_file) )
  {
    $NOW = time();
    $LASTUPDATE = filemtime($target_file);
    
    if ($NOW > ($LASTUPDATE + $wh->getcachetimeout()))
	{
	  $return = "";
      $MAPIN = fopen($URL, "rb");
	  while( !feof( $MAPIN ) )
	  {
        $return .= fread($MAPIN, 1024);
	  }	
      fclose($MAPIN);
	  
	  $MAPOUT = fopen($target_file, "wb");
      fwrite($MAPOUT, $return);
      fclose($MAPOUT);
    }
  }
  else
  {
    $return = "";
    $MAPIN = fopen($URL, "rb");
	while( !feof( $MAPIN ) )
	{
      $return .= fread($MAPIN, 1024);
	}  
    fclose($MAPIN);
	
    $MAPOUT = fopen($target_file, "wb");
    fwrite($MAPOUT, $return);
    fclose($MAPOUT);
  }
  
  //$NEWURL = "";

  if ( $width != "" && $height !="" )
  {
    $NEWURL = "<IMG SRC=\"".$url_target_file."\" WIDTH=\"".$width."\" HEIGHT=\"".$height."\">";
  }
  else
  {
    $NEWURL = "<IMG SRC=\"".$url_target_file."\" WIDTH=\"200\" HEIGHT=\"200\">";
  }	

  return $NEWURL;
}

function fnLatestObstoCache( $latest_obs, $target_file)
{
  global $db, $prefix;
  
  error_reporting(0);  // turn off error reporting, I'm handling for now.

  $old_e_handler = set_error_handler( "WMErrorHandler" );
  
  $wh = new whini( $db, $prefix );
  
  if ( file_exists($target_file) )
  {
    $NOW = time();
    $LASTUPDATE = filemtime($target_file);
    
    if ($NOW > ($LASTUPDATE + $wh->getcachetimeout()))
	{
	  $return = "";
      $file = fopen($latest_obs, "rb");
	  if ( $file )
	  {
	    while( !feof( $file ) )
	    {
          $return .= fread($file, 1024);
	    }	
        fclose($file);
	      
	    $file = fopen($target_file, "wb");
        fwrite($file, $return);
        fclose($file);
	  }
	  else
	  {
	    $target_file = "";
	  }	
	}
  }
  else
  {
    $return = "";
    $file = fopen($latest_obs, "rb");
	if ( $file )
	{
	  while( !feof( $file ) )
	  {
        $return .= fread($file, 1024);
	  }  
      fclose($file);
	
      $file = fopen($target_file, "wb");
      fwrite($file, $return);
      fclose($file);
	}
	else
	{
	  $target_file = "";
	}  
  }
  
  // restore default error handler
  restore_error_handler();
  
  return( $target_file );
}

/************************************************************************/
/* function WMErrorHandler()                                            */
/*                                                                      */
/* Custom error handler so errors are not thrown to the user interface  */
/************************************************************************/

function WMErrorHandler($errno, $errmsg, $filename, $linenum, $vars )
{
    // timestamp for the error entry
    $dt = date("Y-m-d H:i:s (T)");

    // define an assoc array of error string
    // in reality the only entries we should
    // consider are 2,8,256,512 and 1024
    $errortype = array (
                1   =>  "Error",
                2   =>  "Warning",
                4   =>  "Parsing Error",
                8   =>  "Notice",
                16  =>  "Core Error",
                32  =>  "Core Warning",
                64  =>  "Compile Error",
                128 =>  "Compile Warning",
                256 =>  "User Error",
                512 =>  "User Warning",
                1024=>  "User Notice"
                );
    // set of errors for which a var trace will be saved
    $user_errors = array(E_USER_ERROR, E_USER_WARNING, E_USER_NOTICE);
    
    $err = "<errorentry>\n";
    $err .= "\t<datetime>".$dt."</datetime>\n";
    $err .= "\t<errornum>".$errno."</errornum>\n";
    $err .= "\t<errortype>".$errortype[$errno]."</errortype>\n";
    $err .= "\t<errormsg>".$errmsg."</errormsg>\n";
    $err .= "\t<scriptname>".$filename."</scriptname>\n";
    $err .= "\t<scriptlinenum>".$linenum."</scriptlinenum>\n";

    if (in_array($errno, $user_errors))
        $err .= "\t<vartrace>".wddx_serialize_value($vars,"Variables")."</vartrace>\n";
    $err .= "</errorentry>\n\n";
    
    if ($errno == E_USER_ERROR)
        mail("seventhseal@ibdeeming.com","WeatherMagnet: Critical User Error",$err);
}

?>
